<template>
  <nav :style="getNavStyle()"
    :class="[
      { 'expand'         : website.mobileMenu.type                == 'expand' },
      { 'slide'          : website.mobileMenu.type                == 'slide'  },
      { 'aligned-left'   : website.mobileMenu.align.split('-')[1] == 'left'   },
      { 'aligned-right'  : website.mobileMenu.align.split('-')[1] == 'right'  },
      { 'aligned-top'    : website.mobileMenu.align.split('-')[0] == 'top'    },
      { 'aligned-bottom' : website.mobileMenu.align.split('-')[0] == 'bottom' },
    ]">
    <ul>
      <li v-for="(page, index) in pageNamesWithParentPageNames"
        :class="{ expanded: expandedParentPages.indexOf(index) != -1 }"
        v-if="!page.parentPageName">
        <a :href="page.pageName + '.html'"
          class="vlue-mobile-menu-link"
          :class="{ selected : isParentPageSelected(index) }"
          :style="cssVars"
          v-on:click="itemClicked(page.pageName, $event)">
          {{page.pageName}}
        </a>
        <a v-for="(subPage, subIndex) in pageNamesWithParentPageNames"
          v-if="subPage.parentPageName == page.pageName"
          :href="subPage.pageName + '.html'"
          class="vlue-mobile-menu-link"
          :class="{ selected : isPageOrParentPageSelected(subIndex) }"
          :style="cssVars"
          v-on:click="itemClicked(subPage.pageName, $event)">
          {{subPage.pageName}}
        </a>
        <label>
          <input type="button"
            class="vlue-mobile-menu-link-expand-arrow"
            v-on:click="expandCollapseParentPage(index)">
        </label>
      </li>
    </ul>
  </nav>
</template>

<script lang="ts">
import Vue from 'vue'
import store from '../../store/store'
import { mapState, mapGetters } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'viewportWidth',
      'website',
      'dev',
    ]),
    ...mapGetters([
      'pageNamesWithParentPageNames',
      'currentAndParentPageContainerIndexes',
    ]),
    cssVars(): any {
      return {
        '--mobile-menu-color-a': this.website.mobileMenu.colorA || 'black',
        '--mobile-menu-color-b': this.website.mobileMenu.colorB || 'white',
      }
    },
  },
  data() {
    return {
      // array of indexes for parent pages that have been expanded in the nav menu
      expandedParentPages: [] as number[],
    }
  },
  methods: {
    getNavStyle() {
      return {
        ...this.cssVars,
        // set width to viewport width or if unavailable browser width, minus sidebar in dev mode
        width: this.website.mobileMenu.type == 'expand'
        ? 'calc(' + (this.viewportWidth || ('100vw - ' + (this.dev ? '217px' : '17px')))
                  + ' - 40px)'
        : '',
      };
    },
    isPageOrParentPageSelected(index) {
      return (this.currentAndParentPageContainerIndexes.indexOf(index) != -1);
    },
    isParentPageSelected(index) {
      return (this.isPageOrParentPageSelected(index) && !this.isASubPageSelected());
    },
    isASubPageSelected() {
      return (this.currentAndParentPageContainerIndexes.length == 2);
    },
    itemClicked(pageName, event) {
      // prevent page reload
      event.preventDefault();
      // update current page
      store.commit('setProperty', {
        property: {
          name: 'currentPage',
        },
        value: pageName,
      });
      // collapse mobile menu
      this.$emit('itemClicked');
    },
    expandCollapseParentPage(index: number) {
      // add or remove index from array of indexes
      this.expandedParentPages.indexOf(index) == -1
      ? this.expandedParentPages.push(index)
      : this.expandedParentPages.splice(this.expandedParentPages.indexOf(index), 1);
    },
  },
})
</script>

<style lang="scss">
@import "../../style/vars.scss";

.vlue-mobile-menu-container {
  &.expanded {
    nav {
      opacity: 1;
      pointer-events: auto;
      &.slide {
        &.aligned-left {
          left: 0;
        }
        &.aligned-right {
          right: 0;
        }
      }
    }
  }
  .vlue-mobile-menu {
    nav {
      border: 8px #0001 solid;
      border-width: 8px 0;
    }
  }
  nav {
    position: absolute;
    height: calc(100vh - 140px);
    box-sizing: border-box;
    pointer-events: none;
    opacity: 0;
    overflow-y: auto;
    overflow-x: hidden;
    transition: $vlue-transition-duration-long;
    background: var(--mobile-menu-color-b);
    &.expand {
      &.aligned-left {
        left: 0;
      }
      &.aligned-right {
        right: 0;
      }
      &.aligned-top {
        top: 100px;
      }
      &.aligned-bottom {
        bottom: 100px;
      }
    }
    &.slide {
      &.aligned-left {
        left: calc(140px - 100%);
      }
      &.aligned-right {
        right: calc(140px - 100%);
      }
    }
    ul li {
      list-style-type: none;
      position: relative;
      label:nth-child(2) {
        display: none;
      }
      &.expanded {
        a {
          display: block;
        }
        a:first-child {
          border-width: 0;
        }
        a:nth-child(2) {
          animation: navMenuSubPageAppear 0.25s 1;
        }
        label {
          transform: scaleY(-1);
        }
      }
      a:first-of-type {
        display: block;
        &.selected ~ label input {
          border-color: var(--mobile-menu-color-b);
        }
      }
      label {
        position: absolute;
        top: 0;
        right: 0;
        width: 100px;
        height: 100px;
        margin: 0;
        transition: $vlue-transition-duration;
        input {
          position: absolute;
          top: 45%;
          left: 50%;
          width: 30px;
          height: 30px;
          border: solid black 10px;
          border-width: 10px 10px 0 0;
          transform: translate(-50%,-50%) rotate(135deg);
          background: none;
          border-color: var(--mobile-menu-color-a);
        }
      }
      a {
        display: none;
        font-size: 50px;
        text-decoration: none;
        white-space: nowrap;
        padding: 20px 50px;
        color: #314452;
        border: 8px #0001 solid;
        border-width: 0 0 8px;
        color: var(--mobile-menu-color-a);
        &.selected {
          color: var(--mobile-menu-color-b);
          background: var(--mobile-menu-color-a);
          border-width: 0;
        }
        &:not(:first-child) {
          font-size: 30px;
          &:not(:last-of-type) {
            border-width: 0;
          }
        }
      }
    }
  }
  > nav {
    opacity: 1;
    height: 100vh;
    width: calc(100% - 140px);
    top: 0;
  }
}

@keyframes navMenuSubPageAppear {
  from {
    margin-top: 10px;
  } to {
    margin-top: 0;
  }
}
</style>
